package com.yice.webadmin.app.controller;

import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.dto.DatasetOutputDto;
import com.yice.webadmin.app.model.DatasetOutput;
import com.yice.webadmin.app.service.DatasetOutputService;
import com.yice.webadmin.app.vo.DatasetOutputVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 数据集导出操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "数据集导出管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/datasetOutput")
public class DatasetOutputController {

    @Autowired
    private DatasetOutputService datasetOutputService;

    /**
     * 新增数据集导出数据。
     *
     * @param datasetOutputDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"datasetOutputDto.outputId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody DatasetOutputDto datasetOutputDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetOutputDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetOutput datasetOutput = MyModelUtil.copyTo(datasetOutputDto, DatasetOutput.class);
        datasetOutput = datasetOutputService.saveNew(datasetOutput);
        return ResponseResult.success(datasetOutput.getOutputId());
    }

    /**
     * 更新数据集导出数据。
     *
     * @param datasetOutputDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody DatasetOutputDto datasetOutputDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetOutputDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetOutput datasetOutput = MyModelUtil.copyTo(datasetOutputDto, DatasetOutput.class);
        DatasetOutput originaldatasetOutput = datasetOutputService.getById(datasetOutput.getOutputId());
        if (originaldatasetOutput == null) {
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetOutputService.update(datasetOutput, originaldatasetOutput)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除数据集导出数据。
     *
     * @param outputId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long outputId) {
        if (MyCommonUtil.existBlankArgument(outputId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(outputId);
    }

    /**
     * 列出符合过滤条件的数据集导出列表。
     *
     * @param datasetOutputDtoFilter 过滤对象。
     * @param orderParam             排序参数。
     * @param pageParam              分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<DatasetOutputVo>> list(
            @MyRequestBody DatasetOutputDto datasetOutputDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetOutput datasetOutputFilter = MyModelUtil.copyTo(datasetOutputDtoFilter, DatasetOutput.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, DatasetOutput.class);
        List<DatasetOutput> datasetOutputList =
                datasetOutputService.getDatasetOutputListWithRelation(datasetOutputFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(datasetOutputList, DatasetOutput.INSTANCE));
    }

    /**
     * 查看指定数据集导出对象导出。
     *
     * @param outputId 指定对象主键Id。
     * @return 应答结果对象，包含对象导出。
     */
    @GetMapping("/view")
    public ResponseResult<DatasetOutputVo> view(@RequestParam Long outputId) {
        DatasetOutput datasetOutput = datasetOutputService.getByIdWithRelation(outputId, MyRelationParam.full());
        if (datasetOutput == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        DatasetOutputVo datasetOutputVo = DatasetOutput.INSTANCE.fromModel(datasetOutput);
        return ResponseResult.success(datasetOutputVo);
    }

    private ResponseResult<Void> doDelete(Long outputId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        DatasetOutput originaldatasetOutput = datasetOutputService.getById(outputId);
        if (originaldatasetOutput == null) {
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetOutputService.remove(outputId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
